/*******************************************************************

  Copyright (c) 2006, Hyoung-Sun Kim.
  All Rights Reserved.

  You can contact us with
  web site <http://www.voiper.co.kr>
  e-mail <voiper@voiper.co.kr>

  Hyoung-Sun Kim.

  Distributed under the terms of the GNU General Public License

*******************************************************************/

/*

	<asnString.cpp>		2005-02-27,10:11

*/

#include "asnString.h"



const char *GetConstraintTypeNameForParsing( ConstType	ct )
{
	switch(ct)
	{
		case e_uncons:		return "e_unconstrained";
		case e_semicons:	return "e_semiConstrained";
		case e_cons:		return "e_constrained";
		case e_extcons:		return "e_constrainedExt";
	}

	return "e_unconstrained";
}
const char *GetSingleStringTagName( AsnType at )
{
	switch(at)
	{
		case e_printableString:	return "e_asnTagPrintableString";
		case e_ia5String:		return "e_asnTagIA5String";
		case e_numericString:	return "e_asnTagNumericString";
		case e_generalString:	return "e_asnTagGeneralString";
	}

	return "e_asnTagNumericString";
}
const char *GetSingleStringVminName( AsnType at )
{
	switch(at)
	{
		case e_printableString:	return "ASN_PRINTABLE_STRING_VMIN";
		case e_ia5String:		return "ASN_IA5_STRING_VMIN";
		case e_numericString:	return "ASN_NUMERIC_STRING_VMIN";
		case e_generalString:	return "ASN_GENERAL_STRING_VMIN";
	}

	return "ASN_NUMERIC_STRING_VMIN";
}
const char *GetSingleStringVmaxName( AsnType at )
{
	switch(at)
	{
		case e_printableString:	return "ASN_PRINTABLE_STRING_VMAX";
		case e_ia5String:		return "ASN_IA5_STRING_VMAX";
		case e_numericString:	return "ASN_NUMERIC_STRING_VMAX";
		case e_generalString:	return "ASN_GENERAL_STRING_VMAX";
	}

	return "ASN_NUMERIC_STRING_VMAX";
}
const char *GetDoubleStringTagName( AsnType at )
{
	switch(at)
	{
		case e_bmpString:	return "e_asnTagBMPString";
	}

	return "e_asnTagBMPString";
}
const char *GetDoubleStringVminName( AsnType at )
{
	switch(at)
	{
		case e_bmpString:		return "ASN_BMP_STRING_VMIN";
	}

	return "ASN_BMP_STRING_VMIN";
}
const char *GetDoubleStringVmaxName( AsnType at )
{
	switch(at)
	{
		case e_bmpString:	return "ASN_BMP_STRING_VMAX";
	}

	return "ASN_BMP_STRING_VMAX";
}