/*******************************************************************

  Copyright (c) 2006, Hyoung-Sun Kim.
  All Rights Reserved.

  You can contact us with
  web site <http://www.voiper.co.kr>
  e-mail <voiper@voiper.co.kr>

  Hyoung-Sun Kim.

  Distributed under the terms of the GNU General Public License

*******************************************************************/

/*

	<CallMessageMaker.h>	2005-03-20,10:47

*/

#ifndef __2005_03_20__10_47__CALLMESSAGEMAKER_H__
#define __2005_03_20__10_47__CALLMESSAGEMAKER_H__



#include "H323Define.h"
#include "EpDefine.h"
#include "CtrlMessageMaker.h"



/*faststart makers*/
HS_RESULT MakeFastStartRequest( AsnSequenceOf *pSequenceOf, IEndpoint *pEndpoint, ICall *pCall );
HS_RESULT MakeFastStartResponse( AsnSequenceOf *pSequenceOf, IEndpoint *pEndpoint, ICall *pCall );


/*
	h245Address      : Setup, Alert, CallProceed, Connect, Facility, Progress.
	FastStart        : Setup, Alert, CallProceed, Connect, Facility, Progress, Information.
	FastStart Refuse :        Alert, CallProceed, Connect, Facility, Progress, Information.
*/
ASNH225H323_UserInformation *MakeSetup			(StackInfo *pStack, IEndpoint *pEndpoint, NoLockList *pWaits, ICall *pCall);
ASNH225H323_UserInformation *MakeCallProceed	(StackInfo *pStack, IEndpoint *pEndpoint, NoLockList *pWaits, ICall *pCall);
ASNH225H323_UserInformation *MakeAlert			(StackInfo *pStack, IEndpoint *pEndpoint, NoLockList *pWaits, ICall *pCall);
ASNH225H323_UserInformation *MakeConnect		(StackInfo *pStack, IEndpoint *pEndpoint, NoLockList *pWaits, ICall *pCall);
ASNH225H323_UserInformation *MakeFacility		(StackInfo *pStack, IEndpoint *pEndpoint, NoLockList *pWaits, ICall *pCall, ASNH225FacilityReasonChoice pReason);
ASNH225H323_UserInformation *MakeEmpty			(StackInfo *pStack, IEndpoint *pEndpoint, NoLockList *pWaits, ICall *pCall);
ASNH225H323_UserInformation *MakeReleaseComplete(StackInfo *pStack, NoLockList *pWaits, ICall *pCall);

Q931Message *MakeQ931Setup			(StackInfo *pStack, IEndpoint *pEndpoint, NoLockList *pWaits, ICall *pCall);
Q931Message *MakeQ931CallProceed	(StackInfo *pStack, IEndpoint *pEndpoint, NoLockList *pWaits, ICall *pCall);
Q931Message *MakeQ931Alert			(StackInfo *pStack, IEndpoint *pEndpoint, NoLockList *pWaits, ICall *pCall);
Q931Message *MakeQ931Connect		(StackInfo *pStack, IEndpoint *pEndpoint, NoLockList *pWaits, ICall *pCall);
Q931Message *MakeQ931Facility		(StackInfo *pStack, IEndpoint *pEndpoint, NoLockList *pWaits, ICall *pCall, ASNH225FacilityReasonChoice pReason);
Q931Message *MakeQ931Empty			(StackInfo *pStack, IEndpoint *pEndpoint, NoLockList *pWaits, ICall *pCall);
Q931Message *MakeQ931ReleaseComplete(StackInfo *pStack, NoLockList *pWaits, ICall *pCall, Q931CauseType pCause);



#endif/*__2005_03_20__10_47__CALLMESSAGEMAKER_H__*/