/*******************************************************************

  Copyright (c) 2006, Hyoung-Sun Kim.
  All Rights Reserved.

  You can contact us with
  web site <http://www.voiper.co.kr>
  e-mail <voiper@voiper.co.kr>

  Hyoung-Sun Kim.

  Distributed under the terms of the GNU General Public License

*******************************************************************/

/*

	<CtrlMessageMaker.h>	2005-03-20,19:53

*/

#ifndef __2005_03_20__19_53__CTRLMESSAGEMAKER_H__
#define __2005_03_20__19_53__CTRLMESSAGEMAKER_H__



#include "H323Define.h"
#include "EpDefine.h"
#include "MessageUtility.h"


/* H.245(v6) Annex B.3.1 */
#define SESSION_ID_AUDIO		1
#define SESSION_ID_VIDEO		2
#define SESSION_ID_DATA			3


ControlMsg *MakeTerminalCapabilitySet( IEndpoint *pEndpoint, ICall *pCall );
ControlMsg *MakeTerminalCapabilitySetAck( ASNH245TerminalCapabilitySet *pTCS );
ControlMsg *MakeMasterSlaveDetermination( IEndpoint *pEndpoint, HS_UINT pRandom );
ControlMsg *MakeMasterSlaveDeterminationAck( ASNH245MasterSlaveDeterminationAck_decisionChoice pDecision );
ControlMsg *MakeOpenLogicalChannel( ICapability *pCapability, IEndpoint *pEndpoint, ICall *pCall );
ControlMsg *MakeOpenLogicalChannelAck( ASNH245OpenLogicalChannel *pOLC, IEndpoint *pEndpoint, ICall *pCall, ICapability *pCapability );
ControlMsg *MakeOpenLogicalChannelReject( ASNH245OpenLogicalChannel *pOlc, ASNH245OpenLogicalChannelReject_causeChoice pCause);
ControlMsg *MakeEndSessionCommandForDisconnect();



#endif/*__2005_03_20__19_53__CTRLMESSAGEMAKER_H__*/