/*******************************************************************

  Copyright (c) 2006, Hyoung-Sun Kim.
  All Rights Reserved.

  You can contact us with
  web site <http://www.voiper.co.kr>
  e-mail <voiper@voiper.co.kr>

  Hyoung-Sun Kim.

  Distributed under the terms of the GNU General Public License

*******************************************************************/

/*

	<iGatekeeper.c>		2005-03-13,14:45

*/

#include "iGatekeeper.h"


/*****************************************************************************/
/* Registrar member
*/
HS_RESULT new_Registrar( Registrar *pObj )
{
	if( pObj == HS_NULL ) return HS_ERR_NULL_PARAM;

	memset(pObj->target,0,256);
	pObj->registed = FALSE;
	pObj->sn = HS_INVALID_RAS_SEQUENCE_NUMBER;

	return HS_OK;
}


HS_RESULT delete_Registrar( Registrar *pObj )
{
	return HS_OK;
}



/*****************************************************************************/
/* IGatekeeper member
*/
/* new_IGatekeeper */
HS_RESULT new_IGatekeeper( IGatekeeper *pObj )
{
	if( pObj == HS_NULL ) return HS_ERR_NULL_PARAM;

	new_ASNH225EndpointIdentifier( &(pObj->endpointIdentifier) );
	new_ASNH225GatekeeperIdentifier( &(pObj->gatekeeperIdentifier) );

	pObj->registrar = HS_NULL;

	pObj->isGRQ = FALSE;
	pObj->isUseLightRRQ = FALSE;

	pObj->attemptTime = 10;
	pObj->ttl = HS_TTL_DEFAULT;
	pObj->ttlForce = FALSE;

	return HS_OK;
}


/* delete_IGatekeeper */
HS_RESULT delete_IGatekeeper( IGatekeeper *pObj )
{
	if( pObj == HS_NULL ) return HS_ERR_NULL_PARAM;

	delete_ASNH225EndpointIdentifier( &(pObj->endpointIdentifier) );
	delete_ASNH225GatekeeperIdentifier( &(pObj->gatekeeperIdentifier) );

	if( pObj->registrar != HS_NULL )
	{
		delete_Registrar( pObj->registrar );
		free( pObj->registrar );
	}

	return HS_OK;
}


BOOL IGatekeeper_IsRegisted( IGatekeeper *pObj )
{
	if( pObj == HS_NULL ) return FALSE;
	if( pObj->registrar == HS_NULL ) return FALSE;
	return pObj->registrar->registed;
}


