/*******************************************************************

  Copyright (c) 2006, Hyoung-Sun Kim.
  All Rights Reserved.

  You can contact us with
  web site <http://www.voiper.co.kr>
  e-mail <voiper@voiper.co.kr>

  Hyoung-Sun Kim.

  Distributed under the terms of the GNU General Public License

*******************************************************************/

/*

	<RasMessageMaker.h>		2005-03-13,11:45

*/

#ifndef __2005_03_13__11_45__RASMESSAGEMAKER_H__
#define __2005_03_13__11_45__RASMESSAGEMAKER_H__


#include "H323Define.h"
#include "EpDefine.h"
#include "CallMessageMaker.h"



/* endpoint RAS request messages
*/
RasMsg *MakeGRQ( IEndpoint *pEndpoint, HS_USHORT *pSN );
RasMsg *MakeRRQ( IEndpoint *pEndpoint, HS_USHORT *pSN );
RasMsg *MakeURQ( IEndpoint *pEndpoint, HS_USHORT *pSN );
RasMsg *MakeARQ( IEndpoint *pEndpoint, ICall *pCall, HS_USHORT *pSN );
RasMsg *MakeBRQ( IEndpoint *pEndpoint, ICall *pCall, HS_UINT pBandwidth, HS_USHORT *pSN );
RasMsg *MakeDRQ( IEndpoint *pEndpoint, ICall *pCall, ASNH225DisengageReasonChoice pReason, HS_USHORT *pSN );



/* endpoint RAS response messages:
	cause by
	FORCE URQ, DRQ and BRQ
	or IRQ for information from GK
	or receiving unknown message.
*/
RasMsg *MakeUCF( HS_USHORT pMsgSN );
RasMsg *MakeURJ( HS_USHORT pMsgSN, ASNH225UnregRejectReasonChoice pReason );
RasMsg *MakeDCF( HS_USHORT pMsgSN );
RasMsg *MakeDRJ( HS_USHORT pMsgSN, ASNH225DisengageRejectReasonChoice pReason );
RasMsg *MakeBCF( HS_USHORT pMsgSN, HS_UINT pBandwidth );
RasMsg *MakeBRJ( HS_USHORT pMsgSN, ASNH225BandRejectReasonChoice pReason, HS_UINT pBandwidth );
RasMsg *MakeXRS( HS_USHORT pMsgSN );
/* IRR message by IRQ that include unique CRV
*/
RasMsg *MakeIRRwithOne( IEndpoint *pEndpoint, HS_USHORT pMsgSN, ICall *pCall );
/* IRR message by IRQ that include '0' CRV
*/
RasMsg *MakeIRRwithAll( IEndpoint *pEndpoint, HS_USHORT pMsgSN, NoLockList *pCalls );
/* IRR message by UUIEsRequest Field on ACF
*/
RasMsg *MakeIRRwithPDU( IEndpoint *pEndpoint, ICall *pCall, ASNH225H323_UU_PDU *pPdu, BOOL pIsSent, HS_USHORT *pSN );
/* IRR message by irrFrequency Field on ACF
*/
RasMsg *MakeIRRwithTimer( IEndpoint *pEndpoint, ICall *pCall, HS_USHORT *pSN );



#endif/*__2005_03_13__11_45__RASMESSAGEMAKER_H__*/