/*******************************************************************

  Copyright (c) 2006, Hyoung-Sun Kim.
  All Rights Reserved.

  You can contact us with
  web site <http://www.voiper.co.kr>
  e-mail <voiper@voiper.co.kr>

  Hyoung-Sun Kim.

  Distributed under the terms of the GNU General Public License

*******************************************************************/

/*

	<TcpConnect.c>		2005-03-27,16:42

*/

#include "TcpConnect.h"



unsigned __stdcall ConnectThread( void* pArg )
{
	HS_UINT				lDest;
	HS_SOCKET			tSock;
	struct sockaddr_in	tSockIn;

	QMTcpTry	*request = HS_NULL;
	QMConnected *tConnected = HS_NULL;

	if( (request=(QMTcpTry*)pArg) == HS_NULL )
	{
		_endthreadex(0);
		return 0;
	}

	if( (tSock=socket(AF_INET, SOCK_STREAM, 0)) == INVALID_SOCKET )
		tConnected = new_QMConnected( HS_INVALID_SOCKET, request->handle );
	else
	{
		Uchar2Uint(&lDest, request->ip);
		memset( &tSockIn, 0, sizeof(tSockIn) );
		tSockIn.sin_family		= AF_INET;
		tSockIn.sin_addr.s_addr	= htonl( lDest );
		tSockIn.sin_port		= htons( request->port );

		if( connect(tSock,(struct sockaddr*)(&tSockIn),sizeof(tSockIn)) == 0 )
			tConnected = new_QMConnected( tSock, request->handle );
		else
			tConnected = new_QMConnected( HS_INVALID_SOCKET, request->handle );
	}

	PostThreadMessage(request->back, HS_QMESSAGE_CONNECTED, 0, (LPARAM)tConnected );
	delete_QMTcpTry(request);
	_endthreadex(0);
	return 0;
}



HS_RESULT HSConnect( HS_UCHAR *pDest, HS_USHORT pPort, HS_QUEUE_ID pQ, HS_CALL_HANDLE pHandle )
{
	HS_QUEUE_ID tQ;
	QMTcpTry *request = HS_NULL;

	if( pDest == HS_NULL ) return HS_ERR_NULL_PARAM;
	if( (request=new_QMTcpTry(pDest,pPort,pQ,pHandle)) == HS_NULL ) return HS_ERR_H323_MALLOC;

	_beginthreadex( NULL, 0, &ConnectThread, request, 0, &(tQ) );
	return HS_OK;
}



HS_RESULT HSConnectEx( QMTcpTry *pTry )
{
	HS_QUEUE_ID tQ;

	if( pTry == HS_NULL ) return HS_ERR_NULL_PARAM;

	_beginthreadex( NULL, 0, &ConnectThread, pTry, 0, &(tQ) );
	return HS_OK;
}
