/*******************************************************************

  Copyright (c) 2006, Hyoung-Sun Kim.
  All Rights Reserved.

  You can contact us with
  web site <http://www.voiper.co.kr>
  e-mail <voiper@voiper.co.kr>

  Hyoung-Sun Kim.

  Distributed under the terms of the GNU General Public License

*******************************************************************/

/*

	<SipMessage.h>		2005-10-20,00:11

*/

#ifndef __2005_10_19__00_11__SIPMESSAGE_H__
#define __2005_10_19__00_11__SIPMESSAGE_H__



#include "SipDefine.h"
#include "SipHeader.h"



typedef struct
{
	SipHeadLine				mHeadLine;

	SipAllow				*mAllow;
	SipAuthenticationInfo	*mAuthenticationInfo;
	SipAuthorization		*mAuthorization;
	SipCallId				*mCallId;
	NoLockList				mContacts;
	SipContentEncoding		*mContentEncoding;
	SipContentLanguage		*mContentLanguage;
	SipContentLength		*mContentLength;
	SipCSeq					*mCSeq;
	SipExpires				*mExpires;
	SipFrom					*mFrom;
	SipMaxForwards			*mMaxForwards;
	SipMinExpires			*mMinExpires;
	SipProxyAuthenticate	*mProxyAuthenticate;
	SipProxyAuthorization	*mProxyAuthorization;
	NoLockList				mRecordRoutes;
	SipReplyTo				*mReplyTo;
	NoLockList				mRoutes;
	SipTo					*mTo;
	SipUserAgent			*mUserAgent;
	NoLockList				mVias;
	SipWWWAuthenticate		*mWWWAuthenticate;
	SipContentType			*mContentType;
	SipSupported			*mSupported;

#ifdef HS_SIP_ALL_HEADER
	SipAccept				*mAccept;
	SipAcceptEncoding		*mAcceptEncoding;
	SipAcceptLanguage		*mAcceptLanguage;
	SipAlertInfo			*mAlertInfo;
	SipCallInfo				*mCallInfo;
	SipContentDisposition	*mContentDisposition;
	SipDate					*mDate;
	SipErrorInfo			*mErrorInfo;
	SipInReplyTo			*mInReplyTo;
	SipMIMEVersion			*mMIMEVersion;
	SipOrganization			*mOrganization;
	SipPriority				*mPriority;
	SipProxyRequire			*mProxyRequire;
	SipRequire				*mRequire;
	SipRetryAfter			*mRetryAfter;
	SipServer				*mServer;
	SipSubject				*mSubject;
	SipTimestamp			*mTimestamp;
	SipUnsupported			*mUnsupported;
	SipWarning				*mWarning;
#endif/*HS_SIP_ALL_HEADER*/

	char					*mBody;
	HS_UINT					mBodyLen;
} SipMessage;


SipMessage *newm_SipMessage();
HS_RESULT new_SipMessage(void *pObject);
HS_RESULT delete_SipMessage(void *pObject);

BOOL SipMessage_IsRequest(void *pObject);
char *SipMessage_GetBranchId(void *pObject);

HS_RESULT SipMessage_Encode(void *pObject, char *pData, HS_UINT pMax);
HS_RESULT SipMessage_EncodeEx(void *pObject, char *pData, HS_UINT *pPos, HS_UINT pMax);
HS_RESULT SipMessage_Decode(void *pObject, char *pData, HS_UINT pMax);
HS_RESULT SipMessage_DecodeEx(void *pObject, char *pData, HS_UINT *pPos, HS_UINT pMax);

HS_UINT SipMessage_GetExpires(void *pObject);
HS_UINT SipMessage_GetMinExpires(void *pObject);





#endif/*__2005_10_19__00_11__SIPMESSAGE_H__*/