/*******************************************************************

  Copyright (c) 2006, Hyoung-Sun Kim.
  All Rights Reserved.

  You can contact us with
  web site <http://www.voiper.co.kr>
  e-mail <voiper@voiper.co.kr>

  Hyoung-Sun Kim.

  Distributed under the terms of the GNU General Public License

*******************************************************************/

/*

	<IUa.h>		2005-10-06,11:42

*/

#ifndef __2005_10_06__11_42__IUA_H__
#define __2005_10_06__11_42__IUA_H__



#include "SipDefine.h"
#include "UaDefine.h"
#include "IStack.h"





typedef enum
{
	e_UaState_Idle,
	e_UaState_Registed,

	/* if user want to remove ua object, ua can have active dialogue.
	   for these active dialogue, wait until all active dialogue is over.
	   and then free itself.
	*/
	e_UaState_KillMe,
	
	e_UaStateMax
} UaState;


typedef struct
{
	char			mProxy[MAX_NAME_SIZE];
	char			mOutBoundProxy[MAX_NAME_SIZE];
	HS_USHORT		mProxyPort;
	NoLockList		mContacts;
	char			mPassword[MAX_NAME_SIZE];
	char			*mAuthUser;
	/*IDialogue for Register*/
	void			*mRegistrar;
	BOOL			mIsRegisted;

	UaState			mState;

	IStack			*mStack;
	HS_UA_HANDLE	mHandle;
	NoLockList		mDialogues;
} IUa;

HS_RESULT new_IUa(void *pObject, IStack *pStack, HS_UINT pExpires);
HS_RESULT new_IUa_ByUser(void *pObject, HS_UINT pExpires);
HS_RESULT delete_IUa(void *pObject);

HS_RESULT IUa_MakeTag(void *pObject, char *pTag);
HS_RESULT IUa_MakeCallId(void *pObject, char *pId);
SipContactUnit *IUa_GetPrimeContactUnit(void *pObject);
HS_RESULT IUa_ChangeExpires(void *pObject,HS_UINT pNew);

/* finding functions
*/
ChainUnit*	IUa_FindDialogueChainById(void *pObject, char *pCallId);
ChainUnit*	IUa_FindDialogueChainByHandle(void *pObject, HS_CALL_HANDLE pHandle);
void*		IUa_FindDialogueById(void *pObject, char *pCallId);
void*		IUa_FindDialogueByHandle(void *pObject, HS_CALL_HANDLE pHandle);
HS_RESULT	IUa_DeleteDialogue(void *pObject, HS_CALL_HANDLE pHandle);

void*		IUa_FindTransactionByHandle(void *pObject, HS_TR_HANDLE pHandle);





#endif/*__2005_10_06__11_42__IUA_H__*/