/*******************************************************************

  Copyright (c) 2006, Hyoung-Sun Kim.
  All Rights Reserved.

  You can contact us with
  web site <http://www.voiper.co.kr>
  e-mail <voiper@voiper.co.kr>

  Hyoung-Sun Kim.

  Distributed under the terms of the GNU General Public License

*******************************************************************/

/*

	<ppQmessage.c>		2006-03-06,21:13

*/

#include "ppQmessage.h"





/* QmMediaInfo member functions
*/
QmMediaInfo *newm_QmMediaInfo(struct sockaddr_in pAddrIn,HS_USHORT pPort,RtpPayloadType pType,HS_UINT pFpp)
{
	QmMediaInfo *tResult = NULL;

	if( (tResult=(QmMediaInfo*)malloc(sizeof(QmMediaInfo)))==NULL ) return NULL;

	tResult->mAddrIn = pAddrIn;
	tResult->mPort = pPort;
	tResult->mType = pType;
	tResult->mFpp = pFpp;
	return tResult;
}


QmMediaInfo *newm_QmMediaInfoEx(char *pIp,HS_USHORT pRemotePort,HS_USHORT pPort,RtpPayloadType pType,HS_UINT pFpp)
{
	QmMediaInfo *tResult = NULL;

	if( pIp==NULL ) return NULL;
	if( (tResult=(QmMediaInfo*)malloc(sizeof(QmMediaInfo)))==NULL ) return NULL;

	tResult->mAddrIn.sin_family = AF_INET;
	tResult->mAddrIn.sin_addr.s_addr = inet_addr(pIp);
	tResult->mAddrIn.sin_port = htons(pRemotePort);
	tResult->mPort = pPort;
	tResult->mType = pType;
	tResult->mFpp = pFpp;
	return tResult;
}


HS_RESULT deletem_QmMediaInfo(void *pObject)
{
	QmMediaInfo *pObj = (QmMediaInfo*)pObject;

	if( pObj==NULL ) return HS_ERR_NULL_PARAM;

	free(pObj);
	return HS_OK;
}





/* QmSipContext member functions
*/
QmSipContext *newm_QmSipContext(HS_CALL_HANDLE pHandle,char *pType,char *pContext,HS_UINT pLen)
{
	QmSipContext *tResult = NULL;

	if( (tResult=(QmSipContext*)malloc(sizeof(QmSipContext)))==NULL ) return NULL;

	tResult->mHandle = pHandle;
	if( pType==NULL ) tResult->mType = NULL;
	else			  tResult->mType = HSStringAlloc(pType);
	if( pContext==NULL ) tResult->mContext = NULL;
	else
	{
		if( (tResult->mContext=(char*)malloc(pLen+1)) != NULL )
		{
			memcpy(tResult->mContext,pContext,pLen);
			tResult->mContext[pLen] = '\0';
			tResult->mLen= pLen;
		}
	}

	return tResult;
}


HS_RESULT deletem_QmSipContext(void *pObject)
{
	QmSipContext *pObj = (QmSipContext*)pObject;

	if( pObj==NULL ) return HS_ERR_NULL_PARAM;

	if( pObj->mType != NULL ) free(pObj->mType);
	if( pObj->mContext != NULL ) free(pObj->mContext);
	pObj->mLen = 0;

	free(pObj);
	return HS_OK;
}





/* QmCallEnd member functions
*/
QmCallEnd *newm_QmCallEnd(HS_CALL_HANDLE pHandle,HS_UINT pReason)
{
	QmCallEnd *tResult = NULL;

	if( (tResult=(QmCallEnd*)malloc(sizeof(QmCallEnd)))==NULL )
		return NULL;

	tResult->mHandle = pHandle;
	tResult->mReason = pReason;
	return tResult;
}


HS_RESULT deletem_QmCallEnd(void *pObject)
{
	QmCallEnd *pObj = (QmCallEnd*)pObject;

	if( pObj==NULL ) return HS_ERR_NULL_PARAM;

	free(pObj);
	return HS_OK;
}



