/*******************************************************************

  Copyright (c) 2006, Hyoung-Sun Kim.
  All Rights Reserved.

  You can contact us with
  web site <http://www.voiper.co.kr>
  e-mail <voiper@voiper.co.kr>

  Hyoung-Sun Kim.

  Distributed under the terms of the GNU General Public License

*******************************************************************/

/*

	<HSSocketList.h>	2006-04-28,16:31,hskim

*/

#ifndef __HSSOCKET_LIST_H__
#define __HSSOCKET_LIST_H__





#include "HSDefine.h"
#include "TcpConnect.h"





#define HS_SPECIAL_SOCKET_ID		HS_USHORT_MAX
#define HS_INVALID_SOCKET_ID		HS_UINT_MAX





typedef struct
{
	HS_UINT	mId;

	BOOL	mIsTcp;
	BOOL	mIsConnected;

	SOCKET	mSocket;
	struct sockaddr_in	mLocalIn;
	struct sockaddr_in	mRemoteIn;

	/* ! NOTE: if this callback function return HS_NOK,
	           ChainUnit of this unit shall be deleted.
	*/
	HS_RESULT (*CallbackFdEvent)(void*,void*);
} HSSocketUnit;

HS_RESULT new_HSSocketUnit(void *pObject,BOOL pIsTcp,HS_RESULT (*pCallbackFdEvent)(void*,void*));
HSSocketUnit *newm_HSSocketUnit(BOOL pIsTcp,HS_RESULT (*pCallbackFdEvent)(void*,void*));
HS_RESULT delete_HSSocketUnit(void *pObject);
HS_RESULT deletem_HSSocketUnit(void *pObject);

HS_RESULT HSSocketUnit_Socket(void *pObject);
HS_RESULT HSSocketUnit_Bind(void *pObject,HS_UINT pIp,HS_USHORT pPort);
HS_RESULT HSSocketUnit_BindEx(void *pObject,HS_UCHAR *pIp,HS_USHORT pPort);
HS_RESULT HSSocketUnit_Listen(void *pObject);
HS_RESULT HSSocketUnit_Connect(void *pObject,HS_UINT pIp,HS_USHORT pPort,HS_QID pQid);
HS_RESULT HSSocketUnit_ConnectEx(void *pObject,HS_QID pQid);
HS_RESULT HSSocketUnit_ConnectBlock(void *pObject);
HSSocketUnit *HSSocketUnit_Accept(void *pObject,HS_RESULT (*pCallbackFdEvent)(void*,void*));
HS_RESULT HSSocketUnit_AcceptEx(void *pObject,HSSocketUnit *pUnit);

HS_RESULT HSSocketUnit_Receive(void *pObject,unsigned char *pData,int *pLen);
HS_RESULT HSSocketUnit_ReceiveFrom(void *pObject,unsigned char *pData,int *pLen);
HS_RESULT HSSocketUnit_ReceiveFromEx(void *pObject,unsigned char *pData,int *pLen,struct sockaddr_in *pRemoteIn);
HS_RESULT HSSocketUnit_Send(void *pObject,unsigned char *pData,int pLen);
HS_RESULT HSSocketUnit_SendTo(void *pObject,unsigned char *pData,int pLen);
HS_RESULT HSSocketUnit_SendToEx(void *pObject,unsigned char *pData,int pLen,struct sockaddr_in pRemoteIn);
HS_RESULT HSSocketUnit_SendToEx1(void *pObject,unsigned char *pData,int pLen,HS_UINT pIp,HS_USHORT pPort);
HS_RESULT HSSocketUnit_SendToEx2(void *pObject,unsigned char *pData,int pLen,HS_UCHAR *pIp,HS_USHORT pPort);
HS_RESULT HSSocketUnit_Close(void *pObject);

HS_RESULT HSSocketUnit_FdSet(void *pObject,fd_set *pFdSet,int *pFdMax);
HS_RESULT HSSocketUnit_FdIsSet(void *pObject,fd_set *pFdSet,void *pArg);





typedef struct
{
	HS_UINT		mSeed;
	NoLockList	mList;
} HSSocketList;

HS_RESULT new_HSSocketList(void *pObject);
HSSocketList *newm_HSSocketList();
HS_RESULT delete_HSSocketList(void *pObject);
HS_RESULT deletem_HSSocketList(void *pObject);

HS_RESULT HSSocketList_AttachData(void *pObject,HSSocketUnit *pUnit);
HS_RESULT HSSocketList_MakeId(void *pObject,HSSocketUnit *pUnit);

HS_RESULT HSSocketList_FdSet(void *pObject,fd_set *pFdSet,int *pFdMax);
HS_RESULT HSSocketList_FdIsSet(void *pObject,fd_set *pFdSet,void *pArg);
HS_RESULT HSSocketList_Select(void *pObject,fd_set *pFdSet,int pFdMax,HS_UINT pSec,HS_UINT pUSec);

HSSocketUnit *HSSocketList_GetUnitById(void *pObject,HS_UINT pId);
ChainUnit    *HSSocketList_GetChainByRemoteIp(void *pObject,HS_UINT pIp);





#endif/*__HSSOCKET_LIST_H__*/